## kupfer 0+v320

=== wscript ===
#! /usr/bin/env python
# encoding: utf-8

# Kupfer's main wscript description file for Waf, written by Ulrik Sverdrup
# may be distributed, changed, used, etc freely for any purpose

import os
import sys
try:
    from waflib import Configure, Options, Utils, Logs
except ImportError:
    print("You need to upgrade to Waf 1.6! See README.")
    sys.exit(1)

# the following two variables are used by the target "waf dist"
APPNAME="kupfer"
VERSION = "undefined"

def _get_git_version():
    """ try grab the current version number from git"""
    version = None
    if os.path.exists(".git"):
        try:
            version = os.popen("git describe").read().strip()
        except Exception as e:
            print(e)
    return version

def _read_git_version():
    """Read version from git repo, or from GIT_VERSION"""
    version = _get_git_version()
    if not version and os.path.exists("GIT_VERSION"):
        f = open("GIT_VERSION", "r")
        version = f.read().strip()
        f.close()
    if version:
        global VERSION
        VERSION = version

def _write_git_version():
    """ Write the revision to a file called GIT_VERSION,
    to grab the current version number from git when
    generating the dist tarball."""
    version = _get_git_version()
    if not version:
        return False
    version_file = open("GIT_VERSION", "w")
    version_file.write(version + "\n")
    version_file.close()
    return True


_read_git_version()

# these variables are mandatory ('/' are converted automatically)
top = '.'
out = 'build'

config_subdirs = "auxdata help"
build_subdirs = "auxdata data po help"

EXTRA_DIST = [
    #"waf",
    "GIT_VERSION",
]

def _tarfile_append_as(tarname, filename, destname):
    import tarfile
    tf = tarfile.TarFile.open(tarname, "a")
    try:
        tarinfo = tf.gettarinfo(name=filename, arcname=destname)
        tarinfo.uid = 0
        tarinfo.gid = 0
        tarinfo.uname = "root"
        tarinfo.gname = "root"
        with open(filename, "rb") as f:
            tf.addfile(tarinfo, f)
    finally:
        tf.close()

def gitdist(ctx):
    """Make the release tarball using git-archive"""
    import subprocess
    if not _write_git_version():
        raise Exception("No version")
    basename = "%s-%s" % (APPNAME, VERSION)
    outname = basename + ".tar"
    proc = subprocess.Popen(
        ["git", "archive", "--format=tar", "--prefix=%s/" % basename, "HEAD"],
        stdout=subprocess.PIPE)
    fd = os.open(outname, os.O_CREAT | os.O_EXCL | os.O_WRONLY, 0o666)
    os.write(fd, proc.communicate()[0])
    os.close(fd)
    for distfile in EXTRA_DIST:
        _tarfile_append_as(outname, distfile, os.path.join(basename, distfile))
    subprocess.call(["xz", "-6e", outname])
    subprocess.call(["sha1sum", outname + ".xz"])

def dist(ctx):
    "The standard waf dist process"
    import Scripting
    _write_git_version()
    Scripting.g_gz = "gz"
    Scripting.dist(ctx)


def options(opt):
    # options for disabling pyc or pyo compilation
    opt.load("python")
    opt.load("gnu_dirs")
    opt.add_option('--nopyo',action='store_false',default=False,help='Do not install optimised compiled .pyo files [This is the default for Kupfer]',dest='pyo')
    opt.add_option('--pyo',action='store_true',default=False,help='Install optimised compiled .pyo files [Default:not install]',dest='pyo')
    opt.add_option('--no-runtime-deps',action='store_false',default=True,
            help='Do not check for any runtime dependencies',dest='check_deps')
    opt.recurse(config_subdirs)

def configure(conf):
    conf.load("python")
    try:
        conf.check_python_version((3, 5, 0))
    except Configure.ConfigurationError:
        if os.getenv("PYTHON"):
            raise
        Logs.pprint("NORMAL", "Looking for Python 3 instead")
        conf.env["PYTHON"] = ["python3"]
        conf.check_python_version((3, 5, 0))
    conf.load("gnu_dirs")

    conf.load("intltool")

    conf.env["KUPFER"] = Utils.subst_vars("${BINDIR}/kupfer", conf.env)
    conf.env["VERSION"] = VERSION
    conf.recurse(config_subdirs)

    # Setup PYTHONDIR so we install into $DATADIR
    conf.env["PYTHONDIR"] = Utils.subst_vars("${DATADIR}/kupfer", conf.env)
    Logs.pprint("NORMAL",
            "Installing python modules into: %(PYTHONDIR)s" % conf.env)

    opt_build_programs = {
            "rst2man": "Generate and install man page",
        }
    for prog in opt_build_programs:
        try:
            conf.find_program(prog, var=prog.replace("-", "_").upper())
        except conf.errors.ConfigurationError:
            Logs.pprint("YELLOW",
                         "Optional, allows: %s" % opt_build_programs[prog])

    if not Options.options.check_deps:
        return

    python_modules = """
        gi.repository.Gtk
        xdg
        dbus
        """
    for module in python_modules.split():
        conf.check_python_module(module)

    Logs.pprint("NORMAL", "Checking optional dependencies:")

    opt_programs = {
            "dbus-send": "Focus kupfer from the command line",
        }
    opt_pymodules = {
        "gi.repository.Wnck": "Jump to running applications and list windows",
        "gi.repository.Keybinder": "Register global keybindings",
    }

    for prog in opt_programs:
        try:
            conf.find_program(prog, var=prog.replace("-", "_").upper())
        except conf.errors.ConfigurationError:
            Logs.pprint("YELLOW", "Optional, allows: %s" % opt_programs[prog])

    for mod in opt_pymodules:
        try:
            conf.check_python_module(mod)
        except Configure.ConfigurationError:
            Logs.pprint("YELLOW", "module %s is recommended, allows %s" % (
                mod, opt_pymodules[mod]))


def _new_package(bld, name):
    """Add module @name to sources to be installed,
    where the name is the full (relative) path to the package
    """
    obj = bld("py")
    node = bld.path.find_dir(name)
    obj.source = node.ant_glob("*.py")
    obj.install_path = "${PYTHONDIR}/"

    # Find embedded package datafiles
    pkgnode = bld.path.find_dir(name)
    bld.install_files(obj.install_path, pkgnode.ant_glob("icon-list"),
                      relative_trick=True)
    bld.install_files(obj.install_path, pkgnode.ant_glob("*.png"),
                      relative_trick=True)
    bld.install_files(obj.install_path, pkgnode.ant_glob("*.svg"),
                      relative_trick=True)

def _find_packages_in_directory(bld, name):
    """Go through directory @name and recursively add all
    Python packages with contents to the sources to be installed
    """
    for dirname, dirs, filenames in os.walk(name):
        if "__init__.py" in filenames:
            _new_package(bld, dirname)

def _dict_slice(D, keys):
    return dict((k,D[k]) for k in keys)

def build(bld):
    # always read new version
    bld.env["VERSION"] = VERSION

    # kupfer/
    # kupfer module version info file
    version_subst_file = "kupfer/version_subst.py"
    bld(features="subst",
        source=version_subst_file + ".in",
        target=version_subst_file,
        dict = _dict_slice(bld.env,"VERSION DATADIR PACKAGE LOCALEDIR".split())
        )
    bld.install_files("${PYTHONDIR}/kupfer", "kupfer/version_subst.py")

    bld(
        source="kupfer.py",
        install_path="${PYTHONDIR}"
        )

    # Add all Python packages recursively
    _find_packages_in_directory(bld, "kupfer")

    # bin/
    # Write in some variables in the shell script binaries
    bld(features="subst",
        source = "bin/kupfer.in",
        target = "bin/kupfer",
        dict = _dict_slice(bld.env, "PYTHON PYTHONDIR".split())
        )
    bld.install_files("${BINDIR}", "bin/kupfer", chmod=0o755)

    bld(features="subst",
        source = "bin/kupfer-exec.in",
        target = "bin/kupfer-exec",
        dict = _dict_slice(bld.env, "PYTHON PACKAGE LOCALEDIR".split())
        )
    bld.install_files("${BINDIR}", "bin/kupfer-exec", chmod=0o755)

    # Documentation/
    if bld.env["RST2MAN"]:
        # generate man page from Manpage.rst
        bld(
            source = "Documentation/Manpage.rst",
            target = "kupfer.1",
            rule = '%s ${SRC} > ${TGT}' % bld.env["RST2MAN"][0],
        )
        bld.add_group()
        # compress and install man page
        manpage = bld(
            source = "kupfer.1",
            target = "kupfer.1.gz",
            rule = 'gzip -9 -c ${SRC} > ${TGT}',
            install_path = "${MANDIR}/man1",
        )
        man_path = Utils.subst_vars(
                os.path.join(manpage.install_path, manpage.target),
                bld.env)
        bld.symlink_as("${MANDIR}/man1/kupfer-exec.1.gz", man_path)

    # Separate subdirectories
    bld.recurse(build_subdirs)

def distclean(bld):
    bld.exec_command("find ./ -name '*.pyc' -delete")

def intlupdate(util):
    print("You should use intltool-update directly.")
    print("You can read about this in Documentation/Manual.rst")
    print("in the localization chapter!")

def test(bld):
    # find all files with doctests
    python = os.getenv("PYTHON", "python")
    paths = os.popen("grep -lR 'doctest.testmod()' kupfer/").read().split()
    os.putenv("PYTHONPATH", ".")
    all_success = True
    verbose = ("-v" in sys.argv)
    for p in paths:
        print(p)
        cmd = [python, p]
        if verbose:
            cmd.append("-v")
        sin, souterr = os.popen4(cmd)
        sin.close()
        res = souterr.read()
        souterr.close()
        print (res or "OK")
        all_success = all_success and bool(res)
    return all_success

def shutdown(bld):
    pass

=== auxdata/wscript ===
#! /usr/bin/env python
import os

from waflib import Options, Utils, Logs

def options(opt):
    opt.add_option('--no-hooks',
            action='store_true',
            default=False,
            help="Don't run any mime, icon cache or similar update hooks [Default:False]")
    opt.add_option('--no-update-mime',
            action='store_true',
            default=False,
            help='Do not update mime and desktop databases [Default:Update]')
    opt.add_option('--no-update-icon-cache',
            action='store_true',
            default=False,
            help='Do not update icon cache [Default:Update]')

def configure(conf):
    if not Options.options.no_update_mime and not Options.options.no_hooks:
        conf.env["AUXDATA_MIME"] = 1
    if not Options.options.no_update_icon_cache and not Options.options.no_hooks:
        conf.env["UPDATE_ICON_CACHE"] = 1


def build(bld):
    # merge translations into the .desktop file
    # and set it up to be installed
    def install_desktop_file(desktop_subst_file):
        return bld(
            features="intltool_in",
            podir="../po",
            flags = ("-d", "-q", "-u"),
            source = desktop_subst_file  + ".in",
            target = desktop_subst_file,
            install_path = "${DATADIR}/applications",
            chmod = 0o755,
        )

    k_desktop = install_desktop_file("kupfer.desktop")
    x_desktop = install_desktop_file("kupfer-exec.desktop")

    ## install kupfer.desktop as a Thunar sendto object
    kd_install = os.path.join(
        Utils.subst_vars(k_desktop.install_path, bld.env), "kupfer.desktop")
    symlink_location = \
        Utils.subst_vars("${DATADIR}/Thunar/sendto/kupfer.desktop", bld.env)
    symlink_target = \
        os.path.relpath(kd_install, os.path.dirname(symlink_location))
    bld.symlink_as(symlink_location, symlink_target)

    ## install mimetype descriptions

    mimetypes_file = "kupfer-mimetypes.xml"
    bld(
        features="intltool_in",
        podir="../po",
        flags = ("-x", "-q", "-u"),
        source = mimetypes_file  + ".in",
        target = mimetypes_file,
        install_path = "${DATADIR}/mime/packages/",
    )


    def update_mime(bld):
        Logs.pprint('GREEN',"Updating mime database")
        bld.exec_command(["update-mime-database",
                Utils.subst_vars("${DATADIR}/mime", bld.env)])
        bld.exec_command(["update-desktop-database",
                Utils.subst_vars("${DATADIR}/applications", bld.env)])

    if bld.is_install and bld.env["AUXDATA_MIME"]:
        bld.add_post_fun(update_mime)


    ## install kupfer icon
    icons_inst = bld.install_files("${DATADIR}/icons/hicolor",
                                   bld.path.ant_glob("hicolor/**"),
                                   cwd=bld.path.find_dir("hicolor"),
                                   relative_trick=True)

    def update_icon_cache(bld):
        icon_dir = Utils.subst_vars('${DATADIR}/icons/hicolor', bld.env)
        if not Options.options.destdir:
            Logs.pprint('GREEN',"Updating Gtk icon cache.")
            command='gtk-update-icon-cache -q -f -t %s' % icon_dir
            bld.exec_command(command)
        else:
            Logs.pprint('YELLOW','Icon cache not updated. After install, run this:')
            Logs.pprint('YELLOW','gtk-update-icon-cache -q -f -t %s'%icon_dir)

    if icons_inst and bld.is_install and bld.env["UPDATE_ICON_CACHE"]:
        bld.add_post_fun(update_icon_cache)

=== help/wscript ===
#!/usr/bin/env python

# Mallard waf adaptor written by Ulrik Sverdrup
# may be distributed, changed, used, etc freely for any purpose

## Mallard functionality definitions ##
import os
from waflib import Task, TaskGen, Utils

# FIXME: Support for figures

def _read_makefile_am(filename):
    "read a Makefile.am file for HELP_* variable definitions, return a dict"
    varstring = open(filename).read()
    varstring = varstring.replace("\\\n", " ")
    varlines = [L for L in varstring.splitlines() if L.startswith("HELP")]
    return dict(tuple(map(str.strip, var.split("=", 1))) for var in varlines)

def init_mallard(self):
    mf_am = self.path.find_resource(self.variable_definitions)
    HELP_VAR = _read_makefile_am(mf_am.abspath())

    require_vars = "HELP_ID HELP_LINGUAS HELP_FILES".split()
    have_vars = set(var for var in HELP_VAR if HELP_VAR[var])
    missing_vars = set(require_vars).difference(have_vars)
    if missing_vars:
        print("Missing HELP variable declarations in %s:" % (mf_am.abspath()))
        print("\n".join(missing_vars))

    self.bld.env.update(HELP_VAR)
    self.help_install_prefix='${PREFIX}/share/help/'

def apply_mallard(self):
    bld = self.bld
    lst = self.to_list(bld.env["HELP_LINGUAS"])
    cnode = self.path.find_dir("C")

    pages = cnode.ant_glob("*.page")
    legal_xml = cnode.ant_glob("legal.xml")
    self.install_path = Utils.subst_vars(self.help_install_prefix, self.env)

    # Check if the declared page list is consistent
    declared_pages = self.to_list(bld.env["HELP_FILES"])
    pages = [os.path.basename(str(p)) for p in pages]
    missing_pages = set(pages).difference(declared_pages)
    if missing_pages:
        print("Warning: Some pages not declared:")
        print("\n".join([str(p) for p in missing_pages]))

    for lang in lst:
        lang_install_path = os.path.join(self.install_path, lang, bld.env["HELP_ID"])
        node = self.path.find_resource("%s/%s.po" % (lang, lang))
        mo = self.path.find_or_declare("%s/%s.mo" % (lang, lang))
        bld(name='msgfmt', color='BLUE',
            rule='${MSGFMT} ${SRC} -o ${TGT}',
            source=node,
            target=mo,
            )
        for page in pages:
            tsk = self.create_task('itstool')
            out = self.path.find_or_declare('%s/%s' % (lang, page))
            src = self.path.find_resource('C/%s' % page)
            tsk.set_inputs([mo,src])
            tsk.set_outputs(out)
            bld.install_files(lang_install_path, tsk.outputs)
        bld.install_files(lang_install_path, legal_xml)

    c_install_path = os.path.join(self.install_path, "C", bld.env["HELP_ID"])
    for page in cnode.ant_glob("*.page"):
        bld.install_files(c_install_path, page)
    bld.install_files(c_install_path, legal_xml)

Task.task_factory('itstool', '${ITSTOOL} ${ITSTOOLFLAGS} ${SRC} -o ${TGT}',
        color='BLUE')

TaskGen.feature("mallard")(init_mallard)
TaskGen.feature("mallard")(apply_mallard)
TaskGen.after('init_mallard')(apply_mallard)

## End Mallard functionality ##


# Build Configuration

def options(opt):
    pass

def configure(ctx):
    try:
        ctx.find_program('msgfmt', var='MSGFMT')
        ctx.find_program('itstool', var='ITSTOOL')
        ctx.env['ITSTOOLFLAGS'] = '-m'
    except ctx.errors.ConfigurationError:
        pass

def build(bld):
    if bld.env["ITSTOOL"]:
        task = bld(features="mallard",
            variable_definitions="Makefile.am",
        )

=== debian/control ===
Source: kupfer
Section: utils
Priority: optional
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: Hugo Lefeuvre <hle@debian.org>
Build-Depends: debhelper-compat (= 12), dh-python | dh-sequence-python3
Build-Depends-Indep: dh-python,
                     gettext,
                     itstool,
                     intltool,
                     python3-all,
                     python3-docutils
Standards-Version: 4.4.1
Homepage: https://kupferlauncher.github.io/
Vcs-Git: https://salsa.debian.org/python-team/packages/kupfer.git
Vcs-Browser: https://salsa.debian.org/python-team/packages/kupfer

Package: kupfer
Architecture: all
Depends: gir1.2-gtk-3.0,
         gir1.2-keybinder-3.0,
         python3-dbus,
         python3-gi-cairo,
         python3-xdg,
         ${misc:Depends},
         ${python3:Depends}
Recommends: gir1.2-wnck-3.0 (>= 3.20),
            yelp
Suggests: gir1.2-ayatanaappindicator3-0.1,
          python3-setproctitle
Description: fast and lightweight desktop summoner/launcher
 Kupfer is a summoner/launcher in the style of Quicksilver or GNOME Do. It
 can search and browse your files, launch desired applications and object you
 need in a quicker way.
 .
 Kupfer is written in Python 3 and has a flexible architecture based on plugins
 to extend its features.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with python3

clean:
	./waf distclean
	rm -fr build .lock-waf* po/.intlcache
	find Documentation -name "*.html" -delete
	find waflib -name "*.pyc" -delete
	dh $@

override_dh_auto_configure:
	PYTHONDIR=/usr/share/kupfer ./waf configure --prefix=/usr --nopyc --nopyo \
		--bindir=/usr/share/kupfer --no-runtime-deps --no-hooks

override_dh_auto_install:
	./waf install --destdir=$(CURDIR)/debian/kupfer
	install -m 0755 $(CURDIR)/build/bin/kupfer $(CURDIR)/debian/kupfer/usr/share/kupfer/kupfer-activate.sh
	mkdir -p $(CURDIR)/debian/kupfer/usr/share/icons/hicolor/16x16/apps/
	install -m 0644 $(CURDIR)/debian/hicolor/16x16/apps/kupfer.png \
                $(CURDIR)/debian/kupfer/usr/share/icons/hicolor/16x16/apps/kupfer.png
	rm -f $(CURDIR)/debian/kupfer/usr/share/kupfer/kupfer/kupfer
	rm -f $(CURDIR)/debian/kupfer/usr/share/gnome/help/kupfer/*/license.page
	rm -f $(CURDIR)/debian/kupfer/usr/share/kupfer/art/COPYING

override_dh_installdocs:
	make -C Documentation
	dh_installdocs

override_dh_installman:
	rst2man Documentation/Manpage.rst build/kupfer.1
	dh_installman build/kupfer.1

override_dh_installchangelogs:
	dh_installchangelogs NEWS

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/kupfer-$1\.tar\.gz/ \
  https://github.com/kupferlauncher/kupfer/tags .*/v?(\d\S+)\.tar\.gz

## kupfer 324

=== debian/changelog ===
kupfer (324-1) unstable; urgency=medium

  * New upstream release.
  * debian/changelog: Use upstream versioning scheme, use 324
    instead of 0+v324.

 -- Boyuan Yang <byang@debian.org>  Tue, 09 Jan 2024 08:55:15 -0500

kupfer (0+v323-1) unstable; urgency=medium

  * New upstream release. (Closes: #994742)
  * debian/control:
    + Bump Standards-Version to 4.6.2.
    + Bump debhelper compat to v13.
    + No longer use Build-Depends-Indep field, not useful.
    + Add new build-dependency python3-pygments for missing
      doc build feature.
    + Add myself into uploaders list.
    + Drop Hugo Lefeuvre from uploaders due to retirement.
      (Closes: #1050281)
  * debian/copyright: Slight updates.
  * debian/patches/0002-ayanata-appindicator.patch: Refresh patch
    on using Ayanata AppIndicator.
  * debian/patches/0003-Fix-waf-shebang.patch: Fix waf shebang.

 -- Boyuan Yang <byang@debian.org>  Wed, 06 Dec 2023 14:25:23 -0500

kupfer (0+v320-3) unstable; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster:
    + kupfer: Drop versioned constraint on gir1.2-wnck-3.0 in Recommends.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sat, 28 May 2022 01:17:20 +0100

kupfer (0+v320-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Update standards version to 4.5.0, no changes needed.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sat, 21 Aug 2021 13:38:17 +0100

=== debian/control ===
Source: kupfer
Section: utils
Priority: optional
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders:
 Boyuan Yang <byang@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-python3,
 gettext,
 intltool,
 itstool,
 python3-all,
 python3-docutils,
 python3-pygments,
Standards-Version: 4.6.2
Homepage: https://kupferlauncher.github.io/
Vcs-Git: https://salsa.debian.org/python-team/packages/kupfer.git
Vcs-Browser: https://salsa.debian.org/python-team/packages/kupfer

Package: kupfer
Architecture: all
Depends:
 gir1.2-gtk-3.0,
 gir1.2-keybinder-3.0,
 python3-dbus,
 python3-gi-cairo,
 python3-xdg,
 ${misc:Depends},
 ${python3:Depends},
Recommends:
 gir1.2-wnck-3.0,
 yelp,
Suggests:
 gir1.2-ayatanaappindicator3-0.1,
 python3-setproctitle,
Description: fast and lightweight desktop summoner/launcher
 Kupfer is a summoner/launcher in the style of Quicksilver or GNOME Do. It
 can search and browse your files, launch desired applications and object you
 need in a quicker way.
 .
 Kupfer is written in Python 3 and has a flexible architecture based on plugins
 to extend its features.

## kupfer 326

=== debian/changelog ===
kupfer (326-2) unstable; urgency=medium

  * QA upload.
  * Orphan the package.

 -- Boyuan Yang <byang@debian.org>  Sun, 03 Mar 2024 11:30:35 -0500

kupfer (326-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Mon, 26 Feb 2024 19:20:05 -0500

kupfer (325-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Sun, 21 Jan 2024 10:30:37 -0500

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,7 @@
 Source: kupfer
 Section: utils
 Priority: optional
-Maintainer: Debian Python Team <team+python@tracker.debian.org>
-Uploaders:
- Boyuan Yang <byang@debian.org>,
+Maintainer: Debian QA Group <packages@qa.debian.org>
 Build-Depends:
  debhelper-compat (= 13),
  dh-sequence-python3,

## kupfer 327

=== auxdata/wscript ===
#! /usr/bin/env python
import os

from waflib import Options, Utils, Logs


def options(opt):
    opt.add_option(
        "--no-hooks",
        action="store_true",
        default=False,
        help="Don't run any mime, icon cache or similar update hooks [Default:False]",
    )
    opt.add_option(
        "--no-update-mime",
        action="store_true",
        default=False,
        help="Do not update mime and desktop databases [Default:Update]",
    )
    opt.add_option(
        "--no-update-icon-cache",
        action="store_true",
        default=False,
        help="Do not update icon cache [Default:Update]",
    )


def configure(conf):
    if not Options.options.no_update_mime and not Options.options.no_hooks:
        conf.env["AUXDATA_MIME"] = 1
    if (
        not Options.options.no_update_icon_cache
        and not Options.options.no_hooks
    ):
        conf.env["UPDATE_ICON_CACHE"] = 1


def build(bld):
    # merge translations into the .desktop file
    # and set it up to be installed
    def install_desktop_file(desktop_subst_file):
        return bld(
            features="intltool_in",
            podir="../po",
            flags=("-d", "-q", "-u"),
            source=desktop_subst_file + ".in",
            target=desktop_subst_file,
            install_path="${DATADIR}/applications",
            chmod=0o755,
        )

    k_desktop = install_desktop_file("kupfer.desktop")
    _x_desktop = install_desktop_file("kupfer-exec.desktop")

    ## install kupfer.desktop as a Thunar sendto object
    kd_install = os.path.join(
        Utils.subst_vars(k_desktop.install_path, bld.env), "kupfer.desktop"
    )
    symlink_location = Utils.subst_vars(
        "${DATADIR}/Thunar/sendto/kupfer.desktop", bld.env
    )
    symlink_target = os.path.relpath(
        kd_install, os.path.dirname(symlink_location)
    )
    bld.symlink_as(symlink_location, symlink_target)

    ## install mimetype descriptions

    mimetypes_file = "kupfer-mimetypes.xml"
    bld(
        features="intltool_in",
        podir="../po",
        flags=("-x", "-q", "-u"),
        source=mimetypes_file + ".in",
        target=mimetypes_file,
        install_path="${DATADIR}/mime/packages/",
    )

    def update_mime(bld):
        Logs.pprint("GREEN", "Updating mime database")
        bld.exec_command(
            [
                "update-mime-database",
                Utils.subst_vars("${DATADIR}/mime", bld.env),
            ]
        )
        bld.exec_command(
            [
                "update-desktop-database",
                Utils.subst_vars("${DATADIR}/applications", bld.env),
            ]
        )

    if bld.is_install and bld.env["AUXDATA_MIME"]:
        bld.add_post_fun(update_mime)

    ## install kupfer icon
    icons_inst = bld.install_files(
        "${DATADIR}/icons/hicolor",
        bld.path.ant_glob("hicolor/**"),
        cwd=bld.path.find_dir("hicolor"),
        relative_trick=True,
    )

    def update_icon_cache(bld):
        icon_dir = Utils.subst_vars("${DATADIR}/icons/hicolor", bld.env)
        if not Options.options.destdir:
            Logs.pprint("GREEN", "Updating Gtk icon cache.")
            command = f"gtk-update-icon-cache -q -f -t {icon_dir}"
            bld.exec_command(command)
        else:
            Logs.pprint(
                "YELLOW", "Icon cache not updated. After install, run this:"
            )
            Logs.pprint("YELLOW", f"gtk-update-icon-cache -q -f -t {icon_dir}")

    if icons_inst and bld.is_install and bld.env["UPDATE_ICON_CACHE"]:
        bld.add_post_fun(update_icon_cache)

=== debian/changelog ===
kupfer (327-1) unstable; urgency=medium

  * QA upload.
  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Sun, 12 May 2024 09:20:11 -0400

## kupfer 327%2Bgit20240901

=== wscript ===
#! /usr/bin/env python
# encoding: utf-8
# pylint: disable=invalid-name

# Kupfer's main wscript description file for Waf, written by Ulrik Sverdrup
# may be distributed, changed, used, etc freely for any purpose

import os
import subprocess
import sys
from pathlib import Path
import typing as ty

try:
    from waflib import Errors, Logs, Options, Utils
except ImportError:
    print("You need to upgrade to Waf 2! See README.")
    sys.exit(1)

# the following two variables are used by the target "waf dist"
APPNAME = "kupfer"
VERSION = "undefined"


def _get_git_version():
    """try grab the current version number from git"""
    version = None
    if Path(".git").exists():
        try:
            version = os.popen("git describe").read().strip()
        except Exception as e:
            print(e)

    return version


def _read_git_version():
    """Read version from git repo, or from GIT_VERSION"""
    version = _get_git_version()

    if not version:
        gitverfile = Path("GIT_VERSION")
        if gitverfile.exists():
            version = gitverfile.read_text(encoding="UTF-8").strip()

    if version:
        global VERSION  # pylint: disable=global-statement
        VERSION = version


def _write_git_version():
    """Write the revision to a file called GIT_VERSION, to grab the current
    version number from git when generating the dist tarball.
    """

    version = _get_git_version()
    if not version:
        return False

    Path("GIT_VERSION").write_text(f"{version}\n", encoding="UTF-8")

    return True


_read_git_version()

# these variables are mandatory ('/' are converted automatically)
top = "."
out = "build"

config_subdirs = "auxdata help"
build_subdirs = "auxdata data po help"

EXTRA_DIST = [
    "GIT_VERSION",
]


def _tarfile_append_as(tarname, filename, destname):
    import tarfile

    with tarfile.TarFile.open(tarname, "a") as tf:
        tarinfo = tf.gettarinfo(name=filename, arcname=destname)
        tarinfo.uid = 0
        tarinfo.gid = 0
        tarinfo.uname = "root"
        tarinfo.gname = "root"

        with open(filename, "rb") as f:
            tf.addfile(tarinfo, f)


def gitdist(ctx):
    """Make the release tarball using git-archive"""
    if not _write_git_version():
        raise Exception("No version")

    basename = f"{APPNAME}-{VERSION}"
    outname = f"{basename}.tar"

    with subprocess.Popen(
        ["git", "archive", "--format=tar", f"--prefix={basename}/", "HEAD"],
        stdout=subprocess.PIPE,
    ) as proc:
        fd = os.open(outname, os.O_CREAT | os.O_EXCL | os.O_WRONLY, 0o666)
        os.write(fd, proc.communicate()[0])
        os.close(fd)

    for distfile in EXTRA_DIST:
        _tarfile_append_as(outname, distfile, os.path.join(basename, distfile))

    subprocess.call(["xz", "-6e", outname])
    subprocess.call(["sha1sum", f"{outname}.xz"])


def _load_excludes(file: Path) -> ty.Iterable[str]:
    """Load excludes from .gitignore file and covert to glob format."""
    for line in file.read_text().splitlines():
        line = line.strip()
        if not line or line.startswith("#"):
            continue

        # if ignorefile contains '*' - skip whole catalog
        if line == "*":
            yield str(file.parent)
            return

        if line.startswith("/"):
            yield line[1:]
        else:
            yield f"**/{line}"


def _find_gitignores() -> ty.Iterable[Path]:
    """File all .gitignore files, also add .git/info/exclude."""
    for dirname, _dirs, filenames in os.walk("."):
        if ".gitignore" in filenames:
            yield Path(dirname, ".gitignore")

    # 'private' exclude file
    if (path := Path(".git/info/exclude")).exists():
        yield path


def dist(ctx):
    "The standard waf dist process"
    _write_git_version()

    # exclude .git folder
    excl: set[str] = {".git", ".gitattributes", ".gitignore", ".github"}

    # load excluded from .gitignore files
    for file in _find_gitignores():
        excl.update(_load_excludes(file))

    # always add GIT_VERSION to package
    if "GIT_VERSION" in excl:
        excl.remove("GIT_VERSION")

    print(excl)

    ctx.excl = " ".join(excl)


def options(opt):
    # options for disabling pyc or pyo compilation
    opt.load("python")
    opt.load("gnu_dirs")
    opt.add_option(
        "--pyo",
        action="store_true",
        default=False,
        help="Install optimised compiled .pyo files " "[Default:not install]",
        dest="pyo",
    )
    opt.add_option(
        "--no-runtime-deps",
        action="store_false",
        default=True,
        help="Do not check for any runtime dependencies",
        dest="check_deps",
    )
    opt.add_option(
        "--nopycache",
        action="store_true",
        default=False,
        help="Do not install __pycache__ files ",
        dest="nopycache",
    )
    opt.recurse(config_subdirs)


def configure(conf):
    conf.load("python")
    try:
        conf.check_python_version((3, 5, 0))
    except Errors.ConfigurationError:
        if os.getenv("PYTHON"):
            raise

        Logs.pprint("NORMAL", "Looking for Python 3 instead")
        conf.env["PYTHON"] = ["python3"]
        conf.check_python_version((3, 5, 0))

    conf.load("gnu_dirs")
    conf.load("intltool")

    conf.env["KUPFER"] = Utils.subst_vars("${BINDIR}/kupfer", conf.env)
    conf.env["VERSION"] = VERSION
    conf.recurse(config_subdirs)

    # Setup PYTHONDIR so we install into $DATADIR
    conf.env["PYTHONDIR"] = Utils.subst_vars("${DATADIR}/kupfer", conf.env)
    Logs.pprint(
        "NORMAL", "Installing python modules into: %(PYTHONDIR)s" % conf.env
    )

    opt_build_programs = {
        "rst2man": "Generate and install man page",
    }

    for prog, val in opt_build_programs.items():
        try:
            conf.find_program(prog, var=prog.replace("-", "_").upper())
        except conf.errors.ConfigurationError:
            Logs.pprint("YELLOW", f"Optional, allows: {val}")

    if not Options.options.check_deps:
        return

    python_modules = ("gi.repository.Gtk", "xdg", "dbus")

    for module in python_modules:
        conf.check_python_module(module)

    Logs.pprint("NORMAL", "Checking optional dependencies:")

    opt_programs = {
        "dbus-send": "Focus kupfer from the command line",
    }
    opt_pymodules = {
        "gi.repository.Wnck": "Jump to running applications and list windows",
        "gi.repository.Keybinder": "Register global keybindings",
    }

    for prog, val in opt_programs.items():
        try:
            conf.find_program(prog, var=prog.replace("-", "_").upper())
        except conf.errors.ConfigurationError:
            Logs.pprint("YELLOW", f"Optional, allows: {val}")

    for mod, val in opt_pymodules.items():
        try:
            conf.check_python_module(mod)
        except Errors.ConfigurationError:
            Logs.pprint("YELLOW", f"module {mod} is recommended, allows {val}")


def _new_package(bld, name):
    """Add module @name to sources to be installed,
    where the name is the full (relative) path to the package
    """
    obj = bld("py")
    node = bld.path.find_dir(name)
    obj.source = node.ant_glob("*.py")
    obj.install_path = "${PYTHONDIR}/"

    # Find embedded package datafiles
    pkgnode = bld.path.find_dir(name)
    bld.install_files(
        obj.install_path, pkgnode.ant_glob("icon-list"), relative_trick=True
    )
    bld.install_files(
        obj.install_path, pkgnode.ant_glob("*.png"), relative_trick=True
    )
    bld.install_files(
        obj.install_path, pkgnode.ant_glob("*.svg"), relative_trick=True
    )


def _find_packages_in_directory(bld, name):
    """Go through directory @name and recursively add all
    Python packages with contents to the sources to be installed
    """
    for dirname, _dirs, filenames in os.walk(name):
        if "__init__.py" in filenames:
            _new_package(bld, dirname)


def _dict_slice(D, keys):
    return {k: D[k] for k in keys}


def build(bld):
    # always read new version
    bld.env["VERSION"] = VERSION
    bld.env.NOPYCACHE = bld.options.nopycache
    bld.env.PYO = bld.options.pyo

    # kupfer/
    # kupfer module version info file
    version_subst_file = "kupfer/version_subst.py"
    bld(
        features="subst",
        source=f"{version_subst_file}.in",
        target=version_subst_file,
        dict=_dict_slice(
            bld.env, ("VERSION", "DATADIR", "PACKAGE", "LOCALEDIR")
        ),
    )
    bld.install_files("${PYTHONDIR}/kupfer", "kupfer/version_subst.py")

    bld(source="kupfer.py", install_path="${PYTHONDIR}")

    # Add all Python packages recursively
    _find_packages_in_directory(bld, "kupfer")

    # bin/
    # Write in some variables in the shell script binaries
    bld(
        features="subst",
        source="bin/kupfer.in",
        target="bin/kupfer",
        dict=_dict_slice(bld.env, ("PYTHON", "PYTHONDIR")),
    )
    bld.install_files("${BINDIR}", "bin/kupfer", chmod=0o755)

    bld(
        features="subst",
        source="bin/kupfer-exec.in",
        target="bin/kupfer-exec",
        dict=_dict_slice(bld.env, ("PYTHON", "PACKAGE", "LOCALEDIR")),
    )
    bld.install_files("${BINDIR}", "bin/kupfer-exec", chmod=0o755)

    # Documentation/
    if rst2man := bld.env["RST2MAN"]:
        # generate man page from Manpage.rst
        bld(
            source="Documentation/Manpage.rst",
            target="kupfer.1",
            rule="%s ${SRC} > ${TGT}" % rst2man[0],
        )
        bld.add_group()
        # compress and install man page
        manpage = bld(
            source="kupfer.1",
            target="kupfer.1.gz",
            rule="gzip -n -9 -c ${SRC} > ${TGT}",
            install_path="${MANDIR}/man1",
        )
        man_path = Utils.subst_vars(
            os.path.join(manpage.install_path, manpage.target), bld.env
        )
        bld.symlink_as("${MANDIR}/man1/kupfer-exec.1.gz", man_path)

    # Separate subdirectories
    bld.recurse(build_subdirs)


def distclean(bld):
    bld.exec_command("find ./ -name '*.pyc' -or -name '*.pyo' -delete")
    bld.exec_command("find ./ -name '__pycache__' -delete")


def intlupdate(util):
    print("You should use intltool-update directly.")
    print("You can read about this in Documentation/Manual.rst")
    print("in the localization chapter!")


def test(bld):
    # find all files with doctests
    python = os.getenv("PYTHON", "python")
    paths = os.popen("grep -lR 'doctest.testmod()' kupfer/").read().split()
    os.putenv("PYTHONPATH", ".")
    all_success = True
    verbose = "-v" in sys.argv
    for p in paths:
        print(p)
        cmd = [python, p]
        if verbose:
            cmd.append("-v")

        with subprocess.Popen(
            cmd,
            shell=True,
            stdin=subprocess.PIPE,
            stdout=subprocess.PIPE,
            stderr=subprocess.STDOUT,
            close_fds=True,
        ) as pcmd:
            res = b""
            sin, souterr = pcmd.stdin, pcmd.stdout
            if sin:
                sin.close()

            if souterr:
                res = souterr.read()
                souterr.close()

        print(res or "OK")
        all_success = all_success and bool(res)

    return all_success


def shutdown(bld):
    pass

## kupfer 327+git20240901

=== help/Makefile ===
#  This makefile is for convenience.
#
#  Run 'make' to build HTML documentation in the C directory
#  Run 'make $LANG' to update the translation file for language $LANG
#
#  To add a new language, edit Makefile.am

include Makefile.am

C:
	make -C C


$(HELP_LINGUAS): C/*.page
	msgfmt "$@/$@.po" -o "$@/$@.mo"
	itstool -m "$@/$@.mo" -o $@/ C/*.page


html:
	for lang in C $(HELP_LINGUAS) ; do \
		rm -r $$lang ; \
		mkdir $$lang ; \
		yelp-build html -o $$lang /usr/share/help/$$lang/kupfer ; \
	done

=== help/wscript ===
#!/usr/bin/env python

# Mallard waf adaptor written by Ulrik Sverdrup
# may be distributed, changed, used, etc freely for any purpose

## Mallard functionality definitions ##
import os
from pathlib import Path
from waflib import Task, TaskGen, Utils

# FIXME: Support for figures


def _read_makefile_am(filename):
    """Read a Makefile.am file for HELP_* variable definitions, return tuples
    (key, value)
    """
    varstring = Path(filename).read_text(encoding="UTF-8")
    varstring = varstring.replace("\\\n", " ")
    for line in varstring.splitlines():
        if line.startswith("HELP"):
            key, _d, value = line.partition("=")
            yield key.strip(), value.strip()


def init_mallard(self):
    mf_am = self.path.find_resource(self.variable_definitions)
    help_var = dict(_read_makefile_am(mf_am.abspath()))

    require_vars = "HELP_ID HELP_LINGUAS HELP_FILES".split()
    have_vars = set(var for var, val in help_var.items() if val)
    if missing_vars := set(require_vars).difference(have_vars):
        print(f"Missing HELP variable declarations in {mf_am.abspath()}:")
        print("\n".join(missing_vars))

    self.bld.env.update(help_var)
    self.help_install_prefix = "${PREFIX}/share/help/"


def apply_mallard(self):
    bld = self.bld
    lst = self.to_list(bld.env["HELP_LINGUAS"])
    cnode = self.path.find_dir("C")

    pages = cnode.ant_glob("*.page")
    legal_xml = cnode.ant_glob("legal.xml")
    self.install_path = Utils.subst_vars(self.help_install_prefix, self.env)

    # Check if the declared page list is consistent
    declared_pages = self.to_list(bld.env["HELP_FILES"])
    pages = [os.path.basename(str(p)) for p in pages]
    if missing_pages := set(pages).difference(declared_pages):
        print("Warning: Some pages not declared:")
        print("\n".join(missing_pages))

    for lang in lst:
        lang_install_path = os.path.join(
            self.install_path, lang, bld.env["HELP_ID"]
        )
        node = self.path.find_resource(f"{lang}/{lang}.po")
        mo = self.path.find_or_declare(f"{lang}/{lang}.mo")
        bld(
            name="msgfmt",
            color="BLUE",
            rule="${MSGFMT} ${SRC} -o ${TGT}",
            source=node,
            target=mo,
        )
        for page in pages:
            tsk = self.create_task("itstool")
            out = self.path.find_or_declare(f"{lang}/{page}")
            src = self.path.find_resource(f"C/{page}")
            tsk.set_inputs([mo, src])
            tsk.set_outputs(out)
            bld.install_files(lang_install_path, tsk.outputs)

        bld.install_files(lang_install_path, legal_xml)

    c_install_path = os.path.join(self.install_path, "C", bld.env["HELP_ID"])
    for page in cnode.ant_glob("*.page"):
        bld.install_files(c_install_path, page)

    bld.install_files(c_install_path, legal_xml)


Task.task_factory(
    "itstool", "${ITSTOOL} ${ITSTOOLFLAGS} ${SRC} -o ${TGT}", color="BLUE"
)

TaskGen.feature("mallard")(init_mallard)
TaskGen.feature("mallard")(apply_mallard)
TaskGen.after("init_mallard")(apply_mallard)

## End Mallard functionality ##


# Build Configuration


def options(opt):
    pass


def configure(ctx):
    try:
        ctx.find_program("msgfmt", var="MSGFMT")
        ctx.find_program("itstool", var="ITSTOOL")
        ctx.env["ITSTOOLFLAGS"] = "-m"
    except ctx.errors.ConfigurationError:
        pass


def build(bld):
    if bld.env["ITSTOOL"]:
        bld(
            features="mallard",
            variable_definitions="Makefile.am",
        )

=== debian/changelog ===
kupfer (327+git20240901-1) unstable; urgency=medium

  * QA upload.
  * New upstream snapshot.
    + Include fix for command execution. (Closes: #1082576)

 -- Boyuan Yang <byang@debian.org>  Sat, 26 Oct 2024 18:08:45 -0400

## kupfer 328

=== Documentation/Makefile ===
#  This makefile can generate html versions that are pleasant to read
#  needs python-docutils

all: Contributing.html Copyright.html Localization.html Manpage.html \
	Manual.html PluginAPI.html \
	GTKTheming.html VersionHistory.html index.html

%.html: %.rst
	rst2html5 $^ > $@

%.pdf: %.rst
	rst2pdf -o $@ $^

index.html: Manual.html
	cp $^ $@

clean:
	rm -fv *.html

.PHONY: clean all

=== po/wscript ===
def build(bld):
    bld(features="intltool_po", appname=bld.env["PACKAGE"])

=== debian/changelog ===
kupfer (328-1) unstable; urgency=medium

  * QA upload.
  * New upstream release.
  * debian/control: Raise dependency of gir1.2-ayatanaappindicator3-0.1
    from suggests to depends due to upstream changes.
  * debian/patches/0002-ayanata-appindicator.patch: Dropped, fixed upstream.

 -- Boyuan Yang <byang@debian.org>  Fri, 25 Apr 2025 12:27:00 -0400

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  python3-all,
  python3-docutils,
  python3-pygments,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Homepage: https://kupferlauncher.github.io/
 Vcs-Git: https://salsa.debian.org/python-team/packages/kupfer.git
 Vcs-Browser: https://salsa.debian.org/python-team/packages/kupfer
@@ -19,6 +19,7 @@
 Package: kupfer
 Architecture: all
 Depends:
+ gir1.2-ayatanaappindicator3-0.1,
  gir1.2-gtk-3.0,
  gir1.2-keybinder-3.0,
  python3-dbus,
@@ -30,7 +31,6 @@
  gir1.2-wnck-3.0,
  yelp,
 Suggests:
- gir1.2-ayatanaappindicator3-0.1,
  python3-setproctitle,
 Description: fast and lightweight desktop summoner/launcher
  Kupfer is a summoner/launcher in the style of Quicksilver or GNOME Do. It

=== debian/watch ===
version=4
opts="uversionmangle=s/-/~/,filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/kupfer-$1\.tar\.gz/" \
  https://github.com/kupferlauncher/kupfer/tags .*/v?(\d\S+)\.tar\.gz

## kupfer 329

=== debian/changelog ===
kupfer (329-1) unstable; urgency=medium

  * QA upload.
  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Tue, 09 Dec 2025 20:01:55 -0500
